#ifndef DICHOTOMIE_H
#define DICHOTOMIE_H

#include <stdio.h>
/*!
************************************************
* \brief Fonction de recherche d'un entier v dans 
* un tableau T de taille n par recherche dichotomique
* iterative.  
* \param T le tableau 
* \param n la taille du tableau
* \param valeur l'entier recherche
* \return la position dans le tableau de l'entier 
egal a v (comprise entre 0 inclu et n exclu), 
-1 sinon. 
**************************************************/    
int dichotomie(int T[], int n, int valeur); 

/*!
************************************************
* \brief Fonction de recherche d'un entier v dans 
* un tableau T par recherche dichotomique recursive.
* \param  T tableau de n entiers
* \param  debut indice inférieur de l'intervalle considere
* \param  fin indice supérieur de l'intervalle considere
* \param valeur l'entier recherche
* \pre 0 <= debut et fin <= n 
* \return la position dans le tableau de l'entier 
egal a v (comprise entre 0 inclu et n exclu), 
-1 sinon. 
**************************************************/    
int dichotomie_rec(int T[], int debut, int fin, int valeur); 

/*!
************************************************
* \brief Fonction de recherche d'un entier v dans 
* un tableau T de taille n par recherche dichotomique
* recursive.
* \see dichotomie_rec  
* \param T le tableau 
* \param n la taille du tableau
* \param valeur l'entier recherche
* \return la position dans le tableau de l'entier 
egal a v (comprise entre 0 inclu et n exclu), 
-1 sinon. 
**************************************************/    
int dichotomie2(int T[], int n, int valeur);

#endif
